/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"
#define I2C_SLAVE_ADDR 0x10
uint8 command;
uint8 i2csend;
uint8 i2cread;

uint8 i2cwritebuf[100];
uint8 i2creadbuf[100]={1};
int main(void)
{
    CyGlobalIntEnable; /* Enable global interrupts. */
    
    
    uint16 byteCount;

    /* Place your initialization/startup code here (e.g. MyInst_Start()) */
    UART_Start();
    I2C_Start();
  
    
    
    for(;;)
    {
        cystatus status;
        uint32 byteCount;
        uint32 timeoutMs;
        uint32 i;
        uint8 timeOut = 10;
  
        status = CYRET_TIMEOUT;
        timeoutMs = ((uint32) 10u * timeOut); /* Convert from 10mS check to 1mS checks */

        /* Wait with timeout 1mS for packet end */
        byteCount = 0u;
        do
        {
            /* Check packet start */
            if (0u != UART_SpiUartGetRxBufferSize())
            {
                /* Wait for end of packet */
                do
                {
                    byteCount = UART_SpiUartGetRxBufferSize();
                    CyDelayUs(UART_UART_BYTE_TO_BYTE);
                }
                while (byteCount != UART_SpiUartGetRxBufferSize());
                status = CYRET_SUCCESS;
                i2csend = 1;
                break;
            }

            CyDelay(UART_WAIT_1_MS);
            --timeoutMs;
        }
        while (0u != timeoutMs);
        /* Place your application code here. */
        
        for (uint16 i = 0u; i < byteCount; ++i)
        {
            i2cwritebuf[i] = (uint8) UART_SpiUartReadRxData();
        }
        
        command=i2cwritebuf[1];
        
        
        if(i2csend)
        {
            CyDelay(100);
            if(I2C_I2C_MSTR_NO_ERROR == I2C_I2CMasterWriteBuf(I2C_SLAVE_ADDR,i2cwritebuf,byteCount ,I2C_I2C_MODE_COMPLETE_XFER))
            {
            /*If I2C write started without errors, 
            / wait until I2C Master completes write transfer 
            */
            while (0u == (I2C_I2CMasterStatus() & I2C_I2C_MSTAT_WR_CMPLT))
            {
                /* Wait */
            }
            i2csend = 0;
            i2cread=1;
        }
            
            if(i2cread==1)
            {
                CyDelay(100);
                
                if(I2C_I2C_MSTR_NO_ERROR ==  I2C_I2CMasterReadBuf(I2C_SLAVE_ADDR,
                                    i2creadbuf, 0x0F,
                                                I2C_I2C_MODE_COMPLETE_XFER))
                {
                    /* If I2C read started without errors, 
                    / wait until master complete read transfer */
                    while (0u == (I2C_I2CMasterStatus() & I2C_I2C_MSTAT_RD_CMPLT))
                    {
                        /* Wait */
                    }
                    i2cread=0;
                }
   
                CyDelay(10);
                UART_SpiUartPutArray(i2creadbuf,0x0F);                
                CyDelay(10);
                
                
                //refreshing buffers
                for(i=0;i<100;i++)
                {
                i2cwritebuf[i]=0;
                i2creadbuf[i]=0;
                }
                
            }
        
    }
}
}

/* [] END OF FILE */
